﻿Option Explicit On
' Digital Clock App for Windows
' Tom Burt - 07-23-2013 - Initial Code
'
Public Class FormDClockCalendar
    Dim amActive As Boolean = False

    Dim curTime As Date, iTicks As Integer = 0
    Dim TickstoPost As Integer = 2

    Dim aFont As Font

    ' Handle Exit processing
    Sub DoExit()

        TimerClock.Enabled = False
        TimerClock.Dispose()

        C_Properties.C_Position.X = Me.Left
        C_Properties.C_Position.Y = Me.Top

        SaveClockProperties()

        amActive = False

    End Sub

    ' Handle the Show / Hide button and initial settings
    Sub DoShowHide()
        If C_Properties.C_ShowCalendar Then
            C_Properties.C_ShowCalendar = True
            Me.Height = 213
            btnShowHide.Text = Chr(241)
        Else
            C_Properties.C_ShowCalendar = False
            Me.Height = 68
            btnShowHide.Text = Chr(242)
        End If

        My.Application.DoEvents()

    End Sub

    Sub PostTime()
        Dim tDate As String, tTime As String
        curTime = Now
        tDate = Format(curTime, "MMMM dd, yyyy")
        If C_Properties.C_Mode = 0 Then
            ' 12 hour mode
            If C_Properties.C_Seconds Then
                ' Show hours, minutes and seconds AM/PM
                tTime = Format(curTime, "hh:mm:ss tt")
            Else
                ' Show hours, minutes AM/PM
                tTime = Format(curTime, "hh:mm tt")
            End If
        Else
            ' 24 hour mode
            If C_Properties.C_Seconds Then
                ' Show hours, minutes and seconds
                tTime = Format(curTime, "HH:mm:ss")
            Else
                ' Show hours, minutes
                tTime = Format(curTime, "HH:mm")
            End If
        End If
        txtClock.Text = tTime
        iTicks = 0
        Me.Text = tDate
        btnPrefs.Focus()
    End Sub

    ' Set the properties of the Clock from the saved settings
    Sub SetClockProperties()

        Me.Left = C_Properties.C_Position.X
        Me.Top = C_Properties.C_Position.Y

        DoShowHide()

        txtClock.ForeColor = C_Properties.C_ForeColor
        txtClock.BackColor = C_Properties.C_Backcolor
        aFont = New Font(C_Properties.C_Font, 18, FontStyle.Bold)
        txtClock.Font = aFont
        If C_Properties.C_Seconds Then
            ' Post to the screen every second if seconds are showing
            TickstoPost = 2
        Else
            ' Only past to the screen every 30 seconds if only minutes are to show
            TickstoPost = 60
        End If

    End Sub

    Private Sub FormDClock_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        If amActive Then Exit Sub
        amActive = True

        GetClockProperties()

        SetClockProperties()

        TimerClock.Enabled = True

        PostTime()

    End Sub

    Private Sub TimerClock_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles TimerClock.Tick
        iTicks = iTicks + 1
        If iTicks >= TickstoPost Then PostTime()
    End Sub

    Private Sub FormDClock_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        DoExit()
    End Sub

    Private Sub btnPrefs_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnPrefs.Click

        Dim frmDClockOptions As FormDClockOptions, dr As DialogResult

        ' Ensure the Properties struct has the current window position
        C_Properties.C_Position.X = Me.Left
        C_Properties.C_Position.Y = Me.Top

        ' Run the Prefs dialog
        frmDClockOptions = New FormDClockOptions
        dr = frmDClockOptions.ShowDialog()
        frmDClockOptions.Dispose()

        If dr = Windows.Forms.DialogResult.OK Then
            ' Update the clocks properties (already saved by the Options dialog)
            SetClockProperties()
        End If

    End Sub

    Private Sub btnShowHide_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnShowHide.Click
        If C_Properties.C_ShowCalendar Then
            C_Properties.C_ShowCalendar = False
        Else
            C_Properties.C_ShowCalendar = True
        End If

        DoShowHide()
    End Sub
End Class
